LeetCode - Permutations (Java)


LeetCode – Permutations (Java)
Given a collection of numbers, return all possible permutations.
We can get all permutations by the following steps:
[1]
[2, 1]
[1, 2]
[3, 2, 1]
[2, 3, 1]
[2, 1, 3]
[3, 1, 2]
[1, 3, 2]
[1, 2, 3]
Loop through the array, in each iteration, a new number is added to different locations of results of previous iteration. Start from an empty List.

http://gongxuns.blogspot.com/2012/12/leetcode-permutations.html

public ArrayList<ArrayList<Integer>> permute(int[] num) {
 ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
 
 //start from an empty list
 result.add(new ArrayList<Integer>());
 
 for (int i = 0; i < num.length; i++) {
  //list of list in current iteration of the array num
  ArrayList<ArrayList<Integer>> current = new ArrayList<ArrayList<Integer>>();
 
  for (ArrayList<Integer> l : result) {
   // # of locations to insert is largest index + 1
   for (int j = 0; j < l.size()+1; j++) {
    // + add num[i] to different locations
    l.add(j, num[i]);
 
    ArrayList<Integer> temp = new ArrayList<Integer>(l);
    current.add(temp);
 
    //System.out.println(temp);
 
    // - remove num[i] add
    l.remove(j);
   }
  }
 
  result = new ArrayList<ArrayList<Integer>>(current);
 }
 
 return result;
}
X. We can also recursively solve this problem. Swap each element with each element after it.
A more systematic for solving permutation problems
http://blog.csdn.net/tuantuanls/article/details/8717262
建立一棵树,比如说


对于第k层节点来说,就是交换固定了前面 k-1 位,然后分别 swap(k,k), swap(k, k+1) , swap(k, k+2) ...


例如上图中的第三层,固定了第一位(即2),然后分别交换第1,1位,1,2位,1,3位
    public ArrayList<ArrayList<Integer>> permute(int[] num) 
    {
     ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
     permute(num, 0, result);
     return result;
    }
    void permute(int[] num, int start, ArrayList<ArrayList<Integer>> result) 
    {
     if (start >= num.length) //终止条件,递归到末尾节点是,将数组转化为链表
     {
      ArrayList<Integer> item = convertArrayToList(num);
      result.add(item);
     }
     for (int j = start; j <= num.length - 1; j++)
     {
      swap(num, start, j);//交换
      permute(num, start + 1, result);//交换后子代递归
      swap(num, start, j);//恢复到交换前的初始状态,以便于得出下一次的交换结果
     }
    }
对于排列可以通过交换元素得到。例如,输入为[1,2,3]可以由以下思路得到:
  • [1,2,3]本身为一个排列
  • 交换后两个元素得到新排列:[1,3,2]
  • 对于原组合交换第一个和第三个元素得到[3,2,1]
  • 对上一个组合交换后两个元素[3,1,2]
  • 对原组合交换第一个和第二个元素[2,1,3]
  • 交换后两个元素得到[2,3,1]
也就是说可以通过从后往前交换元素得到新的排列,但是在对交换后的排列进行交换的时候会打乱原来的顺序,因此可能得到重复的排列方式。所以可以再交换后恢复到原始组合,再对原始组合进行交换,避免重复的发生。从下面这张图上可以参考排列的思路:
Permutation
void Perm(vector<int>& num, int i, vector<vector<int> > &r) { if (i == num.size()) { r.push_back(num); } for (int k = i; k != num.size(); ++k) { swap(num[k], num[i]); Perm(num, i + 1, r); swap(num[k], num[i]); } } vector<vector<int> > permute(vector<int> &num) { if (!num.size()) { vector<vector<int> > r; return r; } vector<vector<int> > r; Perm(num, 0, r); return r; }

public ArrayList<ArrayList<Integer>> permute(int[] num) {
 ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
 permute(num, 0, result);
 return result;
}
 
void permute(int[] num, int start, ArrayList<ArrayList<Integer>> result) {
 
 if (start >= num.length) {
  ArrayList<Integer> item = convertArrayToList(num);
  result.add(item);
 }
 
 for (int j = start; j <= num.length - 1; j++) {
  swap(num, start, j);
  permute(num, start + 1, result);
  swap(num, start, j);
 }
}
 
private ArrayList<Integer> convertArrayToList(int[] num) {
 ArrayList<Integer> item = new ArrayList<Integer>();
 for (int h = 0; h < num.length; h++) {
  item.add(num[h]);
 }
 return item;
}
 
private void swap(int[] a, int i, int j) {
 int temp = a[i];
 a[i] = a[j];
 a[j] = temp;
}

X.
http://www.cnblogs.com/springfor/p/3888044.html
这道题就用循环递归解决子问题。
因为求所有组合,这就意味着不能重复使用元素,要用visited数组。
有因为是所有可能的组合,所以循环length次,就是这里面每位都有可能有length个可能性。
正因为如此,每一层递归就不需要传递一个start点,告诉他从哪开始(因为都是从头开始循环)。
Therefore, we need a for loop to process all the possibilities in each element of the array.  For example, array[0] can be 1, 2, 3, 4.  While in the case of array[0] = 1, array[1] can be 2, 3, 4.  Recursively doing this we can get all the possible permutations.
1. Create a new array "visited[num.size()]" to keep the which element of the original array has been visited, so as to ensure only the remaining elements will be processed.  For example, in case of array[0] = 1, only 2,3,4 can be process for array[1].
2. Remove the last element from the array, and resume the visit flag in order to process next possible permutation. For example, after having [1, 2, 3, 4], remove 4 from array (array will be fallen back to [1, 2, 3]), and reset visit flag of the 3rd element to un-visited.  Then go into the next iteration: put 4 into the array.  New array this time would be [1, 2, 4].
  1.     public ArrayList<ArrayList<Integer>> permute(int[] num) {  
  2.         ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();  
  3.         ArrayList<Integer> element = new ArrayList<Integer>();  
  4.         boolean[] visited = new boolean[num.length];  
  5.         helper(num, result, element, visited);  
  6.         return result;  
  7.     }  
  8.       
  9.     public void helper(int[] num, ArrayList<ArrayList<Integer>> result, ArrayList<Integer> element, boolean[] visited){  
  10.         if (element.size() == num.length){  
  11.             // duplicate element and add it to result (element would be changed from time to time. If directly use element  
  12.             // only result would be changed when element changed)  
  13.             result.add(new ArrayList<Integer>(element));   
  14.             return;  
  15.         }  
  16.           
  17.         for(int i=0; i<num.length; i++){  
  18.             if(!visited[i]){  
  19.                 visited[i] = true;  
  20.                 element.add(num[i]);  
  21.                 helper(num, result, element, visited);  
  22.                   
  23.                 // After providing a complete permutation, pull out the last number,   
  24.                 element.remove(element.size()-1);  
  25.                 visited[i] = false;  
  26.             }  
  27.         }  
  28.     }  

若输入数组为[3,2,1,4]
  • 对给定的数组进行排序,这里排序后即[1,2,3,4];
  • 从后往前找第一个顺序对,所谓顺序对即第一个数小于第二个数,如(3,4);
  • 顺序对中较小的数字对应的位置即为交换点,如上面例子中3的位置。交换交换点上的数字与从后往前第一个比交换点上数值大的数字。因为交换点数字位于一个顺序对中,因此肯定是可以找到这样的数字的(上面例子中为4);
  • 将交换后的交换数字后面的所有数字顺序颠倒。(上面例子中交换后3为最后一个数字,因此不需要交换)
  • 重复上面的步骤,直到数组中不存在顺序对为止(此时的数组变为[4,3,2,1])
该算法不仅对非重复数组有用,对重复的是一样的,因为两个元素相等是为非顺序对,所以不会交换,也就不会出现重复的情况了。
http://tech-wonderland.net/blog/leetcode-permutations-i-and-ii.html
Related: LeetCode - Permutations II
Read full article from LeetCode – Permutations (Java)

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts